
#declare RimTexture = texture { T_Brass_4D }

#declare spec = union {
  torus { 0.9, 0.03
    texture { RimTexture }
    scale <1,2,1>
    rotate <90,0,0>
  }
  difference {
    cylinder { <0,0,-0.03> <0,0,0.03> 0.9 }
    sphere {
      0,0.9
      scale <1,1,0.1>;
      translate -0.075 * z
    }
    texture { NBoldglass }
  }
}


#declare leg_clip = union {
  box { <-0.05,-0.1,-0.17> <0.05,-0.05,0.03>
    texture { RimTexture }
  }
  box { <-0.05, 0.1,-0.17> <0.05, 0.05,0.03>
    texture { RimTexture }
  }
  cylinder { <0,-0.06,-0.1> <0,0.06,-0.1> 0.03
    texture { pigment { Black } }
  }
}

#declare leg_leg = union {
  box { <-0.025,-0.05,-4> <0.025,0.05,-0.05> }
  box { <-0.025,-0.05,-0.5> <0.025,0.05,0.5>
    rotate <-45,0,0>
    translate <0,-0.335,-4.30>
  }
  texture { RimTexture }
}

#declare leg1 = union {
  object { leg_clip }
  object { leg_leg
    translate <0,0,0.1>
    rotate <0,-22,0>
    translate <0,0,-0.1>
  }
}

#declare leg2 = union {
  object { leg_clip }
  object { leg_leg
    translate <0,0,0.1>
    rotate <0,16,0>
    translate <0,0,-0.1>
  }
}

#declare glasses = union {
  object { spec translate <-1.4,0,0> }
  object { spec translate <1.4,0,0> }
  torus { 1.1, 0.025
    texture { RimTexture }
    scale <1,2,1>
    translate <0,0.2,-0.9>
    scale <0.75,1,1>
    clipped_by { box { <-1,-1,0> <1,1,1> scale 1.01 } }
  }
  object { leg1
    translate <-2.365,0,0>
  }
  object { leg2
    translate <2.365,0,0>
  }
}
