#declare body = lathe {
   cubic_spline
   6,
   <0, 0> <0.5, 0.5> <0.5,3> <1,5.5> <1,6.5> <0,7>

   rotate <0,0,-90>
   scale <1,0.5,0.5>
   translate <-3.5,0,0>
   texture {
     pigment { Black }
     finish { phong 0.6 }
      normal {
        bump_map { tga "pen.tga" }
        turbulence 1
      }
   }
}


#declare tip_cylinder = difference {
  cylinder { <-1,0,0> <1,0,0> 0.5 }
  cylinder { <-1,0,0> <1,0,0> 0.4
    scale 1.01
  }
  clipped_by { box { <-1,0,-0.5> <0.8,0.5,0.5> scale 1.01 } }
}

#declare tip_clipper = union {
  #declare tip_rear_clip = cylinder { <0,-0.5, 0> <0,0.5, 0> 0.3
    scale <3 + 1/3,1,1>
  }
  #declare tip_front_clip = cylinder { <0,-0.5, 0> <0,0.5, 0> 0.5
    scale <2,1,1>
  }

  object { tip_rear_clip    translate <-1,0,-0.5> }
  object { tip_rear_clip    translate <-1,0, 0.5> }
  object { tip_front_clip   translate <1,0,-0.5> }
  object { tip_front_clip   translate <1,0, 0.5> }
}


#declare tip = difference {
  union {
    difference {
      object { tip_cylinder }
      object { tip_clipper }
      scale <1,0.5,1>
    }
    sphere { <0.5,0.225,-0.03> 0.07 }
    sphere { <0.5,0.225, 0.03> 0.07 }
  }
  box { <-0.5,-1,-0.03> <1,1,0.03> }

  texture { T_Silver_1E }
}

#declare pen = union {
  object { body }
  object { tip
    translate <4.15,-0.25,0>
  }
  translate <-0.75,0,0>
}
